﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;
using System.Web.Configuration;

public partial class TouringBikeProductManager : System.Web.UI.Page {
    private string connectionString = WebConfigurationManager.ConnectionStrings["AdventureWorks"].ConnectionString;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            FillAllProductList();
        }
    }

    private void FillAllProductList()
    {
        /*
        ddlProducts.Items.Clear();

        string selectSQL = "SELECT name, productid FROM saleslt.product WHERE productcategoryid=7";
        SqlConnection conn = new SqlConnection(connectionString);
        SqlCommand cmd = new SqlCommand(selectSQL, conn);
        SqlDataReader rd;

        try
        {
            conn.Open();
            rd = cmd.ExecuteReader();

            while (rd.Read())
            {
                ListItem item = new ListItem();
                item.Text = rd["Name"].ToString();
                item.Value = rd["ProductID"].ToString();
                ddlProducts.Items.Add(item);
            }

            rd.Close();
        }
        catch (Exception error)
        {
            lblStatus.Text = "데이터베이스를 읽는 동안 오류가 발생했습니다.<br />";
            lblStatus.Text += error.Message;
        }
        finally
        {
            conn.Close();
        }
        */
        ddlProducts.Items.Clear();

        string selectSQL = "SELECT name, productid FROM saleslt.product WHERE productcategoryid=7";
        SqlConnection conn = new SqlConnection(connectionString);
        SqlCommand cmd = new SqlCommand(selectSQL, conn);
        SqlDataAdapter da = new SqlDataAdapter(cmd);
        DataSet ds = new DataSet();

        try
        {
            da.Fill(ds, "TouringBike");

            DataRow row;
            for (int i = 0; i < ds.Tables["TouringBike"].Rows.Count; i++)
            {
                row = ds.Tables["TouringBike"].Rows[i];

                ListItem item = new ListItem();
                item.Text = row["Name"].ToString();
                item.Value = row["ProductID"].ToString();
                ddlProducts.Items.Add(item);
            }

            //DataRow row = ds.Tables["TouringBike"].Rows[0];
            /*foreach (DataRow row in ds.Tables["TouringBike"].Rows)
            {
                ListItem item = new ListItem();
                string name = (string)row["Name"];
                item.Text = row["Name"].ToString();
                item.Value = row["ProductID"].ToString();
                ddlProducts.Items.Add(item);
            }*/
        }
        catch (Exception error)
        {
            lblStatus.Text = "데이터베이스를 읽는 동안 오류가 발생했습니다.<br />";
            lblStatus.Text += error.Message;
        }
        finally
        {
            conn.Close();
        }
    }

    protected void btnUpdate_Click(object sender, EventArgs e)
    {
        /* 직접 데이터 접근 방식 코드
        string updateSQL = "UPDATE saleslt.product SET Name=@pname, ";
        updateSQL += "ProductNumber=@pnum, StandardCost=@sc, ";
        updateSQL += "ListPrice=@lp, SellStartDate=@ssd WHERE productid=@pid";

        SqlConnection conn = new SqlConnection(connectionString);
        SqlCommand cmd = new SqlCommand(updateSQL, conn);

        cmd.Parameters.AddWithValue("@pname", txtProductName.Text);
        cmd.Parameters.AddWithValue("@pnum", txtProductNumber.Text);
        cmd.Parameters.AddWithValue("@sc", double.Parse(txtStandardCost.Text));
        cmd.Parameters.AddWithValue("@lp", double.Parse(txtListPrice.Text));
        cmd.Parameters.AddWithValue("@ssd", DateTime.Parse(txtSellStartDate.Text));
        cmd.Parameters.AddWithValue("@pid", txtProductID.Text);

        int updated = 0;

        try
        {
            conn.Open();
            updated = cmd.ExecuteNonQuery();
            lblStatus.Text = updated.ToString() + " 개의 레코드가 수정되었습니다.";
        }
        catch (Exception error)
        {
            lblStatus.Text = "데이터베이스에 쓰는 동안 오류가 발생했습니다.<br />";
            lblStatus.Text += error.Message;
        }
        finally
        {
            conn.Close();
        }
        */

        // 비연결기반 데이터 접근 방식 코드
        SqlConnection conn = new SqlConnection(connectionString);
        SqlDataAdapter da = new SqlDataAdapter();
                
        string selectSQL = "SELECT * FROM saleslt.product WHERE productid=@pid";
        SqlCommand cmdSelect = new SqlCommand(selectSQL, conn);
        cmdSelect.Parameters.AddWithValue("@pid", txtProductID.Text);
        da.SelectCommand = cmdSelect;

        string updateSQL = "UPDATE saleslt.product SET Name=@pname, ";
        updateSQL += "ProductNumber=@pnum, StandardCost=@sc, ";
        updateSQL += "ListPrice=@lp, SellStartDate=@ssd WHERE productid=@pid";
        SqlCommand cmdUpdate = new SqlCommand(updateSQL, conn);
        cmdUpdate.Parameters.AddWithValue("@pname", txtProductName.Text);
        cmdUpdate.Parameters.AddWithValue("@pnum", txtProductNumber.Text);
        cmdUpdate.Parameters.AddWithValue("@sc", double.Parse(txtStandardCost.Text));
        cmdUpdate.Parameters.AddWithValue("@lp", double.Parse(txtListPrice.Text));
        cmdUpdate.Parameters.AddWithValue("@ssd", DateTime.Parse(txtSellStartDate.Text));
        cmdUpdate.Parameters.AddWithValue("@pid", txtProductID.Text);
        da.UpdateCommand = cmdUpdate;

        DataSet ds = new DataSet();

        try
        {
            da.Fill(ds, "TouringBike");

            DataTable table = ds.Tables["TouringBike"];
            DataRow[] rows = table.Select("productid=" + txtProductID.Text);
            for (int i = 0; i < rows.Length; i++)
            {
                rows[i]["Name"] = txtProductName.Text;
                rows[i]["ProductNumber"] = txtProductNumber.Text;
                rows[i]["StandardCost"] = double.Parse(txtStandardCost.Text);
                rows[i]["ListPrice"] = double.Parse(txtListPrice.Text);
                rows[i]["SellStartDate"] = DateTime.Parse(txtSellStartDate.Text);

                da.Update(ds, "TouringBike");
            }

            lblStatus.Text = rows.Length.ToString() + " 개의 레코드가 수정되었습니다.";
        }
        catch (Exception error)
        {
            lblStatus.Text = "데이터베이스에 쓰는 동안 오류가 발생했습니다.<br />";
            lblStatus.Text += error.Message;
        }
    }

    protected void ddlProducts_SelectedIndexChanged(object sender, EventArgs e)
    {
        lblStatus.Text = "";

        string selectSQL = "SELECT * FROM saleslt.product WHERE productid=@productid";
        SqlConnection conn = new SqlConnection(connectionString);
        SqlCommand cmd = new SqlCommand(selectSQL, conn);
        cmd.Parameters.AddWithValue("@productid", ddlProducts.SelectedValue);
        SqlDataReader rd;

        try
        {
            conn.Open();
            rd = cmd.ExecuteReader();
            rd.Read();

            txtProductID.Text = rd["ProductID"].ToString();
            txtProductName.Text = rd["Name"].ToString();
            txtProductNumber.Text = rd["ProductNumber"].ToString();
            txtStandardCost.Text = rd["StandardCost"].ToString();
            txtListPrice.Text = rd["ListPrice"].ToString();
            txtSellStartDate.Text = rd["SellStartDate"].ToString();

            rd.Close();
        }
        catch (Exception error)
        {
            lblStatus.Text = "데이터베이스를 읽는 동안 오류가 발생했습니다.<br />";
            lblStatus.Text += error.Message;
        }
        finally
        {
            conn.Close();
        }
    }

    protected void btnDelete_Click(object sender, EventArgs e)
    {
        /* 직접 데이터 접근 방식 코드
        string updateSQL = "DELETE FROM saleslt.product ";
        updateSQL += "WHERE productid=@pid";

        SqlConnection conn = new SqlConnection(connectionString);
        SqlCommand cmd = new SqlCommand(updateSQL, conn);

        cmd.Parameters.AddWithValue("@pid", txtProductID.Text);

        int deleted = 0;

        try
        {
            conn.Open();
            deleted = cmd.ExecuteNonQuery();
            lblStatus.Text = deleted.ToString() + " 개의 레코드가 삭제되었습니다.";

            txtProductID.Text = "";
            txtProductName.Text = "";
            txtProductNumber.Text = "";
            txtStandardCost.Text = "";
            txtListPrice.Text = "";
            txtSellStartDate.Text = "";
        }
        catch (Exception error)
        {
            lblStatus.Text = "데이터를 삭제하는 동안 오류가 발생했습니다.<br />";
            lblStatus.Text += error.Message;
        }
        finally
        {
            conn.Close();
        }

        if (deleted > 0)
        {
            FillAllProductList();
        }
        */

        // 비연결기반 데이터 접근 방식 코드
        SqlConnection conn = new SqlConnection(connectionString);
        SqlDataAdapter da = new SqlDataAdapter();

        string selectSQL = "SELECT * FROM saleslt.product WHERE productid=@pid";
        SqlCommand cmdSelect = new SqlCommand(selectSQL, conn);
        cmdSelect.Parameters.AddWithValue("@pid", txtProductID.Text);
        da.SelectCommand = cmdSelect;

        string updateSQL = "DELETE FROM saleslt.product ";
        updateSQL += "WHERE productid=@pid";
        SqlCommand cmdDelete = new SqlCommand(updateSQL, conn);
        cmdDelete.Parameters.AddWithValue("@pid", txtProductID.Text);
        da.DeleteCommand = cmdDelete;

        DataSet ds = new DataSet();

        try
        {
            da.Fill(ds, "TouringBike");

            DataTable table = ds.Tables["TouringBike"];
            DataRow[] rows = table.Select("productid=" + txtProductID.Text);
            for (int i = 0; i < rows.Length; i++)
            {
                rows[i].Delete();

                da.Update(ds, "TouringBike");
            }

            lblStatus.Text = rows.Length.ToString() + " 개의 레코드가 수정되었습니다.";

            txtProductID.Text = "";
            txtProductName.Text = "";
            txtProductNumber.Text = "";
            txtStandardCost.Text = "";
            txtListPrice.Text = "";
            txtSellStartDate.Text = "";

            FillAllProductList();
        }
        catch (Exception error)
        {
            lblStatus.Text = "데이터를 삭제하는 동안 오류가 발생했습니다.<br />";
            lblStatus.Text += error.Message;
        }
    }

    protected void btnInsertNewProduct_Click(object sender, EventArgs e)
    {
        /* 직접 데이터 접근 방식 코드
        string insertSQL = "INSERT INTO saleslt.product";
        insertSQL += "(name, productnumber, standardcost, listprice, ";
        insertSQL += "productcategoryid, sellstartdate) VALUES ";
        insertSQL += "(@pname, @pnum, @sc, @lp, 7, GETDATE())";

        SqlConnection conn = new SqlConnection(connectionString);
        SqlCommand cmd = new SqlCommand(insertSQL, conn);

        cmd.Parameters.AddWithValue("@pname", txtProductName.Text);
        cmd.Parameters.AddWithValue("@pnum", txtProductNumber.Text);
        cmd.Parameters.AddWithValue("@sc", double.Parse(txtStandardCost.Text));
        cmd.Parameters.AddWithValue("@lp", double.Parse(txtListPrice.Text));

        int inserted = 0;

        try
        {
            conn.Open();
            inserted = cmd.ExecuteNonQuery();
            lblStatus.Text = inserted.ToString() + " 개의 레코드가 삽입되었습니다.";
        }
        catch (Exception error)
        {
            lblStatus.Text = "데이터베이스에 쓰는 동안 오류가 발생했습니다.<br />";
            lblStatus.Text += error.Message;
        }
        finally
        {
            conn.Close();
        }

        if (inserted > 0)
        {
            FillAllProductList();
        }
        */

        // 비연결기반 데이터 접근 방식 코드
        SqlConnection conn = new SqlConnection(connectionString);
        SqlDataAdapter da = new SqlDataAdapter();

        string selectSQL = "SELECT * FROM saleslt.product WHERE productid=@pid";
        SqlCommand cmdSelect = new SqlCommand(selectSQL, conn);
        cmdSelect.Parameters.AddWithValue("@pid", txtProductID.Text);
        da.SelectCommand = cmdSelect;

        string insertSQL = "INSERT INTO saleslt.product";
        insertSQL += "(name, productnumber, standardcost, listprice, ";
        insertSQL += "productcategoryid, sellstartdate) VALUES ";
        insertSQL += "(@pname, @pnum, @sc, @lp, 7, GETDATE())";
        SqlCommand cmdInsert = new SqlCommand(insertSQL, conn);
        cmdInsert.Parameters.AddWithValue("@pname", txtProductName.Text);
        cmdInsert.Parameters.AddWithValue("@pnum", txtProductNumber.Text);
        cmdInsert.Parameters.AddWithValue("@sc", double.Parse(txtStandardCost.Text));
        cmdInsert.Parameters.AddWithValue("@lp", double.Parse(txtListPrice.Text));
        da.InsertCommand = cmdInsert;
        
        DataSet ds = new DataSet();

        try
        {
            da.Fill(ds, "TouringBike");
            DataTable table = ds.Tables["TouringBike"];
            DataRow row = table.NewRow();
            row["Name"] = txtProductName.Text;
            row["ProductNumber"] = txtProductNumber.Text;
            row["StandardCost"] = double.Parse(txtStandardCost.Text);
            row["ListPrice"] = double.Parse(txtListPrice.Text);
            table.Rows.Add(row);

            da.Update(ds, "TouringBike");

            lblStatus.Text = "레코드가 성공적으로 삽입되었습니다.";

            FillAllProductList();
        }
        catch (Exception error)
        {
            lblStatus.Text = "데이터베이스에 쓰는 동안 오류가 발생했습니다.<br />";
            lblStatus.Text += error.Message;
        }
    }

    protected void btnClearInformation_Click(object sender, EventArgs e)
    {
        txtProductID.Text = "";
        txtProductName.Text = "";
        txtProductNumber.Text = "";
        txtStandardCost.Text = "";
        txtListPrice.Text = "";
        txtSellStartDate.Text = "";

        lblStatus.Text = "제품 정보를 모두 입력한 후 <새 상품 등록> 버튼을 클릭하세요.";
    }
}

