﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;

public partial class WebPartPage : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        // WebPartManager의 개인 설정 범위가 User 이고
        // WebPartManager의 개인 설정 범위 상태가 Shared로 들어 갈수 있을 경우
        if (wpmManager.Personalization.Scope ==
            PersonalizationScope.User &&
            wpmManager.Personalization.CanEnterSharedScope)
        {
            wpmManager.Personalization.ToggleScope();
        }
    }

    protected void Page_Init(object sender, EventArgs e)
    {
        foreach (WebPartDisplayMode mode in wpmManager.SupportedDisplayModes)
        {
            string modeString = mode.Name;
            if (mode.IsEnabled(wpmManager))
            {
                ListItem liItem = new ListItem(modeString, modeString);
                ddlWebPartDisplayMode.Items.Add(liItem);
            }
        }
    }

    protected void ddlWebPartDisplayMode_SelectedIndexChanged(object sender, EventArgs e)
    {
        string selectedMode = ddlWebPartDisplayMode.SelectedValue;
        WebPartDisplayMode mode = wpmManager.SupportedDisplayModes[selectedMode];
        if (mode != null)
        {
            wpmManager.DisplayMode = mode;
        }
    }
}